local RecognizerRelease="r090417a" 
-- <guild> und <char> in messages mglich
-- Erklrungstexte ergnzt

local Me=CreateFrame("Frame","Recognizer")
Me:SetScript("OnEvent",function(this,event,arg1,arg2,arg3,arg4) Me:OnEvent(event,arg1,arg2,arg3,arg4) end)
Me:RegisterEvent("VARIABLES_LOADED")

-- -------------------------------
-- DB-Init
-- -------------------------------
RecognizerDB={Guilds={},Chars={},Signals={}}
RecognizerDBpC={Guilds={},Chars={},Signals={{name="Signal 1",msg="",sound="RaidWarning"}}}
local dfltRecognizerDB=RecognizerDBpC
local dfltRecognizerDBpC=RecognizerDBpC

-- -------------------------------
-- Variablenzuweisungen
-- -------------------------------
local MaxEntries=12
local MaxSignals=3
local Sounds={"---","AuctionWindowOpen","Deathbind Sound","FriendJoinGame","igBackPackCoinOK","igQuestFailed",
	"MapPing","OrcExploration","RaidWarning","ReadyCheck","TellMessage"}
local L={}
local InitStore={}
local ConfigSelect={}
local LastTarget={}
-- Lokale Kopien der DB Variablen
local Guilds={}
local Chars={}
local Signals={}

function Me:OnEvent(event,arg1,arg2,arg3,arg4)
	if event=="PLAYER_TARGET_CHANGED" then Me:PLAYER_TARGET_CHANGED(arg1,arg2,arg3,arg4)
	elseif event=="VARIABLES_LOADED" then Me:VARIABLES_LOADED()
	end
end

-- -----------------------------------------------------------------
-- Initialisierung
-- -----------------------------------------------------------------
function Me:VARIABLES_LOADED()
	L=Lang.Recognizer

	-- -------------------------------
	-- Fr Events registrieren
	-- -------------------------------
	Me:RegisterEvent("PLAYER_TARGET_CHANGED")
	Me:Initialize()
end

function Me:Initialize()
	-- -------------------------------
	-- ggf. Defaults bernehmen
	-- -------------------------------
	for key,value in pairs(dfltRecognizerDBpC) do
		if type(dfltRecognizerDBpC[key])=="table" then
			RecognizerDBpC[key]=RecognizerDBpC[key] or dfltRecognizerDBpC[key]
			for ikey,ivalue in pairs(dfltRecognizerDBpC[key]) do
				RecognizerDBpC[key][ikey]=RecognizerDBpC[key][ikey] or dfltRecognizerDBpC[key][ikey]
			end
		else RecognizerDBpC[key]=RecognizerDBpC[key] or dfltRecognizerDBpC[key] end
	end
	for key,value in pairs(dfltRecognizerDB) do
		if type(dfltRecognizerDB[key])=="table" then
			RecognizerDB[key]=RecognizerDB[key] or dfltRecognizerDB[key]
			for ikey,ivalue in pairs(dfltRecognizerDB[key]) do
				RecognizerDB[key][ikey]=RecognizerDB[key][ikey] or dfltRecognizerDB[key][ikey]
			end
		else RecognizerDB[key]=RecognizerDB[key] or dfltRecognizerDB[key] end
	end

	for i=1,MaxSignals,1 do
		if not RecognizerDBpC.Signals[i] then RecognizerDBpC.Signals[i]={name="",msg="",sound=""} end
	end

	-- -------------------------------
	-- Slash-Kommandos definieren
	-- -------------------------------
	SLASH_Recognizer1 = "/recognizer"
	SLASH_Recognizer2 = "/reco"
	SlashCmdList["Recognizer"]=function (cmd) Me:Slash(cmd) end

	-- -------------------------------
	-- Ende der Initialisierung
	-- -------------------------------
	Guilds=RecognizerDBpC.Guilds
	Chars=RecognizerDBpC.Chars
	Signals=RecognizerDBpC.Signals
	Me:Print(Me:gsub(L["initmsg"],"<release>",RecognizerRelease))
end

function Me:SetBackground(widget,red,green,blue,alpha)
	widget.texture=widget:CreateTexture()
	widget.texture:SetAllPoints(widget)
	widget.texture:SetTexture(red,green,blue,alpha)
end

-- -----------------------------------------------------------------
-- Aufruf von /recognizer
-- -----------------------------------------------------------------
function Me:Slash(parm)
	Me:Config("signals")
end
-- -----------------------------------------------------------------
-- Config Frame
-- -----------------------------------------------------------------
function RecognizerCallConfig(parm) 
	if recAcceptChange("RecognizerCallConfig('"..parm.."')") then
		if parm=="close" then
			RecognizerConfig:Hide()
			InitStore={}
		else
			Me:Config(parm) 
		end
	end
end
function Me:Config(parm)
	if parm=="" then parm="help" end
	RecognizerConfig_ButtonSave:SetText(L["ButtonSave"])
	RecognizerConfig_ButtonSave.tooltipText=L["ttSave"]
	RecognizerConfig_ButtonClose:SetText(L["ButtonClose"])
	RecognizerConfig_ButtonClose.tooltipText=L["ttClose"]
	RecognizerConfig_ButtonHelp:SetText(L["Buttonhelp"])
	RecognizerConfig_ButtonHelp.tooltipText=L["ttHelp"]
	RecognizerConfig_ButtonGuilds:SetText(L["Buttonguilds"])
	RecognizerConfig_ButtonGuilds.tooltipText=L["ttGuilds"]
	RecognizerConfig_ButtonChars:SetText(L["Buttonchars"])
	RecognizerConfig_ButtonChars.tooltipText=L["ttChars"]
	RecognizerConfig_ButtonSignals:SetText(L["Buttonsignals"])
	RecognizerConfig_ButtonSignals.tooltipText=L["ttSignals"]
	RecognizerConfig_Help:Hide()
	RecognizerConfig_Entries:Hide()
	RecognizerConfig_Signals:Hide()
	Me:SetBackground(RecognizerConfig,0.1,0.05,0.05,0.7)
	RecognizerConfig_Release:SetText(RecognizerRelease)
	RecognizerConfig:Show()
	if parm=="help" then RecognizerConfigHelp()
	elseif parm=="guilds" then RecognizerConfigEntries("guilds")
	elseif parm=="chars" then RecognizerConfigEntries("chars")
	elseif parm=="signals" then RecognizerConfigSignals()
	end
	ConfigHasChanged=false
	RecognizerConfig_ButtonSave:Hide()
end

function RecognizerConfigSave()
	if ConfigSelect[1]=="guilds" then recConfigEntriesSave("guilds")
	elseif ConfigSelect[1]=="chars" then recConfigEntriesSave("chars")
	elseif ConfigSelect[1]=="signals" then recConfigSignalsSave()
	end
	ConfigHasChanged=false
	RecognizerConfig_ButtonSave:Hide()
end

-- -----------------------------------------------------------------
-- Eventhandler fr Changes
-- -----------------------------------------------------------------
function RecognizerConfigEdit(editbox)
	if InitStore[editbox:GetName()]~=editbox:GetText() then RecognizerSetConfigChanged() end
end
function RecognizerConfigTooltip(widget)
	GameTooltip:SetOwner(widget, "ANCHOR_RIGHT")
	if widget.tooltipText then
		GameTooltip:SetText(widget.tooltipText, 1.0, 0.8, 0.0, 1 )
		GameTooltip:Show();
	end
end

-- -----------------------------------------------------------------
-- Hilfe anzeigen
-- -----------------------------------------------------------------
function RecognizerConfigHelp()
	ConfigSelect={"help"}
	RecognizerConfig_Title:SetText(L["ButtonHelp"])
	RecognizerConfig_Description:SetText(L["HelpHelp"])
	local text=""
	for i=1,#L["HelpText"],1 do text=text.."\n"..L["HelpText"][i] end
	RecognizerConfig_Help_Text:SetText(text)
	RecognizerConfig_Help:Show()
end


-- -----------------------------------------------------------------
-- Gilden bearbeiten
-- -----------------------------------------------------------------
function RecognizerConfigEntries(parm)
	RecognizerConfig_Description:SetText(L["Help"..parm])
	ConfigSelect={parm}
	RecognizerConfig_Title:SetText(L["Button"..parm])
	local table=Chars
	if parm=="guilds" then table=Guilds end
	local name={}
	local sig={}
	for i=1,MaxEntries,1 do
		if i<=#table then
			name[i]=table[i].name or ""
			sig[i]=tonumber(table[i].signal)
		else
			name[i]=""
			sig[i]=1
		end
		local widget=getglobal("RecognizerConfig_Entries_"..i.."_Sig")
		InitStore[widget:GetName()]=Signals[sig[i]].name
		widget:SetText(Signals[sig[i]].name)
		widget=getglobal("RecognizerConfig_Entries_"..i.."_Name")
		InitStore[widget:GetName()]=name[i]
		widget:SetText(name[i])
		Me:SetBackground(widget,0.3,0.3,0.3,1)
	end
	ConfigSelect={parm,name,sig,LastTarget}
	local lasttgt=Me:NextEntry("first")
	if lasttgt then
		RecognizerConfig_Entries_AddTarget:Show()
		RecognizerConfig_Entries_NextTarget.tooltipText=L["ttNextTarget"]
		RecognizerConfig_Entries_NextTarget:Show()
		RecognizerConfig_Entries_AddTarget:SetText("+ "..lasttgt)
	else
		RecognizerConfig_Entries_AddTarget:Hide()
		RecognizerConfig_Entries_NextTarget:Hide()
	end
	RecognizerConfig_Entries:Show()
end

function RecognizerConfigEntriesNext(widget)
	local name={strsplit("_",widget)}
	nr=tonumber(name[#name-1])
	local cnr=ConfigSelect[3][nr]+1
	if cnr>MaxSignals then cnr=1 end
	local swaps=0
	while Signals[cnr].name=="" and swaps<2 do
		cnr=cnr+1
		if cnr>MaxSignals then 
			cnr=1 
			swaps=swaps+1
		end
	end
	ConfigSelect[3][nr]=cnr
	getglobal("RecognizerConfig_Entries_"..nr.."_Sig"):SetText(Signals[cnr].name)
	RecognizerSetConfigChanged()
end

function RecognizerConfigEntriesAddTarget()
	local name=ConfigSelect[2]
	local newname=ConfigSelect[4][1]["name"]
	if ConfigSelect[1]=="guilds" then newname=ConfigSelect[4][1]["guild"] end
	local new=nil
	for i=1,MaxEntries,1 do
		if new==nil and name[i]=="" then new=i end
		if strlower(newname)==strlower(name[i]) then new=-1 end
	end
	if new==nil then
		Me:Print(L["noslotfree"])
	elseif new==-1 then
		Me:Print(Me:gsub(L["isinlist"],"<name>",newname))
	else
		ConfigSelect[2][new]=newname
		getglobal("RecognizerConfig_Entries_"..new.."_Name"):SetText(newname)
		RecognizerSetConfigChanged()
	end
end

function RecognizerConfigEntriesNextTarget()
	local show=Me:NextEntry("next")
	RecognizerConfig_Entries_AddTarget:SetText("+ "..show)
end
function Me:NextEntry(mode)
	local ret=nil
	local fg="name"
	if ConfigSelect[1]=="guilds" then fg="guild" end
	local maxtries=#ConfigSelect[4]
	if maxtries>0 then
		local try=1
		local check=nil
		if mode=="first" then check=ConfigSelect[4][1][fg] end
		while try<=maxtries and check==nil do
			local current=ConfigSelect[4][1]
			tinsert(ConfigSelect[4],current)
			tremove(ConfigSelect[4],1)
			check=ConfigSelect[4][1][fg]
			try=try+1
		end
		ret=ConfigSelect[4][1][fg]
	end
	local current=ConfigSelect[4][1]
	if current then
		local tt=Me:gsub(Me:gsub(L["ttAddTarget"],"<name>",current["name"]),"<guild>",(current["guild"] or L["none"]))
		tt=Me:gsub(Me:gsub(tt,"<race>",current["lrace"]),"<class>",current["lclass"])
		RecognizerConfig_Entries_AddTarget.tooltipText=tt
	end
	return ret
end

-- -----------------------------------------------------------------
-- Signalkategorien bearbeiten
-- -----------------------------------------------------------------
function RecognizerConfigSignals()
	RecognizerConfig_Description:SetText(L["Helpsignals"])
	ConfigSelect={parm}
	RecognizerConfig_Title:SetText(L["Buttonsignals"])
	for i=1,MaxSignals,1 do
		local widget=getglobal("RecognizerConfig_Signals_"..i.."_Sound")
		widget:SetText(Signals[i].sound or "")
		widget=getglobal("RecognizerConfig_Signals_"..i.."_Name")
		InitStore[widget:GetName()]=(Signals[i].name or "")
		widget:SetText(Signals[i].name or "")
		Me:SetBackground(widget,0.3,0.3,0.3,1)
		widget=getglobal("RecognizerConfig_Signals_"..i.."_Msg")
		InitStore[widget:GetName()]=(Signals[i].msg or "")
		widget:SetText(Signals[i].msg or "")
		Me:SetBackground(widget,0.3,0.3,0.3,1)
	end
	ConfigSelect={"signals"}
	RecognizerConfig_Signals:Show()
end

function RecognizerConfigSignalsNext(widget)
	local name={strsplit("_",widget)}
	nr=tonumber(name[#name-1])
	local sound=getglobal("RecognizerConfig_Signals_"..nr.."_Sound")
	local actual=sound:GetText()
	local new=1
	for i=1,#Sounds,1 do
		if Sounds[i]==actual then new=i+1 end
	end
	if new>#Sounds then new=1 end
	sound:SetText(Sounds[new])
	RecognizerSetConfigChanged()
	PlaySound(Sounds[new])
end

-- -----------------------------------------------------------------
-- Prfen ob nderungen vorgenommen wurden, ggf. sichern/verwerfen
-- -----------------------------------------------------------------
function RecognizerSetConfigChanged()
	ConfigHasChanged=true
	RecognizerConfig_ButtonSave:Show()
end
function RecognizerConfigAcceptSave()
	RecognizerConfig_Unsaved:Hide()
	RecognizerConfigSave()
	assert(loadstring(ConfigHasChanged_Continue))()
	ConfigHasChanged_Continue=nil
end
function RecognizerConfigAcceptIgnore()
	ConfigHasChanged=False
	RecognizerConfig_Unsaved:Hide()
	assert(loadstring(ConfigHasChanged_Continue))()
	ConfigHasChanged_Continue=nil
	RecognizerConfig_ButtonSave:Hide()
end
function RecognizerConfigAcceptAbort()
	RecognizerConfig_Unsaved:Hide()
	ConfigHasChanged_Continue=nil
end
function recAcceptChange(continue)
	local accept=true
	if ConfigHasChanged==true then
		ConfigHasChanged_Continue=continue
		accept=false
		RecognizerConfig_Unsaved_Text:SetText(L["unsaved"])
		RecognizerConfig_Unsaved_Save:SetText(L["save"])
		RecognizerConfig_Unsaved_Ignore:SetText(L["ignore"])
		RecognizerConfig_Unsaved_Abort:SetText(L["abort"])
		Me:SetBackground(RecognizerConfig_Unsaved,0.5,0,0,0.9)
		RecognizerConfig_Unsaved:Show()
	end
	return accept
end

-- -----------------------------------------------------------------
-- Entries sichern
-- -----------------------------------------------------------------
function recConfigEntriesSave()
	local list={}
	for i=1,MaxEntries,1 do
		local name=getglobal("RecognizerConfig_Entries_"..i.."_Name"):GetText()
		if name~="" then tinsert(list,{name=name,signal=ConfigSelect[3][i]}) end
	end
	if ConfigSelect[1]=="chars" then
		Chars=list
		RecognizerDBpC.Chars=list
		Me:Print(Me:gsub(L["charssaved"],"<count>",#list))
	else
		Guilds=list
		RecognizerDBpC.Guilds=list
		Me:Print(Me:gsub(L["guildssaved"],"<count>",#list))
	end
end

-- -----------------------------------------------------------------
-- Signale sichern
-- -----------------------------------------------------------------
function recConfigSignalsSave()
	local newSignals={}
	for i=1,MaxSignals,1 do
		local sound=getglobal("RecognizerConfig_Signals_"..i.."_Sound"):GetText()
		local name=getglobal("RecognizerConfig_Signals_"..i.."_Name"):GetText()
		local msg=getglobal("RecognizerConfig_Signals_"..i.."_Msg"):GetText()
		tinsert(newSignals,{name=name,sound=sound,msg=msg})
	end
	Signals=newSignals
	RecognizerDBpC.Signals=newSignals
	Me:Print(Me:gsub(L["signalssaved"],"<count>",#Signals))
end

-- -----------------------------------------------------------------
-- Event: Targetwechsel
-- -----------------------------------------------------------------
function Me:PLAYER_TARGET_CHANGED()
	if UnitExists("target") and UnitIsPlayer("target") then
		local name=UnitName("target")
		local guild=GetGuildInfo("target")
		local signal=nil
		for i=1,#Guilds,1 do
			if Guilds[i].name==guild then signal=Guilds[i].signal end
		end
		for i=1,#Chars,1 do
			if Chars[i].name==name then signal=Chars[i].signal end
		end
		if signal then
			if Signals[signal].msg then 
				Me:Print(Me:gsub(Me:gsub(Signals[signal].msg,"<guild>",guild),"<char>",name),'ffff0000')
			end
			if Signals[signal].sound then PlaySound(Signals[signal].sound) end
		end

		for i=1,#LastTarget,1 do
			if LastTarget[i]["name"]==name then name="" end
		end
		if name~="" then
			local lrace,race=UnitRace("target")
			local lclass,class=UnitClass("target")
			tinsert(LastTarget,1,{name=name,guild=guild,faction=UnitFactionGroup("target"),race=race,class=class,lrace=lrace,lclass=lclass,sex=UnitSex("target")})
			if #LastTarget>10 then tremove(LastTarget) end
		end
	end
end

-- function replacement for gsub, because we want simply a string returned
function Me:gsub(instr,key,replace)
	local replaced,number=gsub(instr,key,replace)
	return replaced
end
-- simple print to chatlog
function Me:Print(text,color)
	if color then text="|c"..color..text.."|r" end
	DEFAULT_CHAT_FRAME:AddMessage("|cffddbb00Recognizer:|r "..text)
end
